#include "vector.h"

#include "definitions.h"

#include <assert.h>

/** 
   \file vector.c

   \brief Implementation of the basic operations between points. 

   Implementation of the basic operations between points.
   
   \sa point.h.
*/

double VectorSquaredDistanceTopologyMin(double t2,unsigned int s,unsigned int *tp,
					double *v1,double *v2)
{
  unsigned int i;
  double n,v;
  
  n=0.0;
  if (tp==NULL)
    {
      for(i=0;((i<s)&&(n<t2));i++)
	{
	  v=v1[i]-v2[i];
	  n+=(v*v);
	}
    }
  else
    {
      for(i=0;((i<s)&&(n<t2));i++)
	{
	  v=v1[i]-v2[i];
	  if ((tp[i]==TOPOLOGY_S)&&((v<-M_PI)||(v>M_PI)))
	    PI2PI(v);
	  n+=(v*v);
	}
    }
  return(n);
}

double VectorNorm(unsigned int s,double *v)
{
  unsigned int i;
  double n;

  n=0.0;
  for(i=0;i<s;i++)
    n+=(v[i]*v[i]);
  n=sqrt(n);

  return(n);
}

void VectorNormalize(unsigned int s,double *v)
{
  unsigned int i;
  double n;
  
  n=VectorNorm(s,v);

  assert(n>1e-6);

  for(i=0;i<s;i++)
    v[i]/=n;
}
